<?xml version="1.0"?>
<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN" "http://www.wapforum.org/DTD/wml_1.1.xml">
<%@ page session="false" buffer="none" %>
<%-- Licensed Materials - Property of IBM, 5724-E76, (C) Copyright IBM Corp. 2001, 2004 - All Rights reserved. --%>

<%@ taglib uri="/WEB-INF/tld/engine.tld" prefix="wps" %>

<wml>
    <template>
    
        <%-- basic template for the popup menu --%>
        <%-- name="{0}" is included to allow cards to re-define the menu items --%>
        <%-- label="{1}" is the label of the item in the popup menu --%>
        <%-- {2} is the action of the menu item --%>
        <wps:popupMenuTemplate>
            <do type="options" name="{0}" label="{1}">
                {2}
            </do>
        </wps:popupMenuTemplate>

        <%-- Basic menu setup (assumes user is not logged in --%>
        
        <%-- 1. Back --%>
        <wps:popupMenuItem item="1">
            <wps:popupMenuParam param="0">
                Item1
            </wps:popupMenuParam>
            <wps:popupMenuParam param="1">
                <wps:text key="link.back.wml" bundle="nls.engine"/>
            </wps:popupMenuParam>
            <wps:popupMenuParam param="2">
                <prev/>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
            
        
        <%-- 2. Home --%>
        <wps:popupMenuItem item="2">
            <wps:popupMenuParam param="0">
                Item2
            </wps:popupMenuParam>
            <wps:popupMenuParam param="1">
                <wps:text key="link.home.wml" bundle="nls.engine"/>
            </wps:popupMenuParam>
            <wps:popupMenuParam param="2">
                <go href="<wps:url home="public" />"/>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
        
        <%-- 3. LogIn --%>
        <wps:popupMenuItem item="3">
            <wps:popupMenuParam param="0">
                Item3
            </wps:popupMenuParam>
            <wps:popupMenuParam param="1">
                <wps:text key="link.login.wml" bundle="nls.engine"/>
            </wps:popupMenuParam>
            <wps:popupMenuParam param="2">
                <go href="<wps:url screen="Login" />"/>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
        
        <%-- 4. (for non-Openwave clients, just leave the definition blank) --%>
        
        <%-- 5. (for non-Openwave clients, just leave the definition blank) --%>
            
        <%-- 6. (for non-Openwave clients, just leave the definition blank) --%>
            
        <%-- 7. Select Pages --%>
        <wps:popupMenuItem item="7">
            <wps:popupMenuParam param="0">
                Item7
            </wps:popupMenuParam>
            <wps:popupMenuParam param="1">
                <wps:text key="link.select.page.wml" bundle="nls.engine"/>
            </wps:popupMenuParam>
            <wps:popupMenuParam param="2">
                <go href="<wps:url screen="SelectPage" />"/>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
            

        <%-- specific changes for when the user is logged in --%>        
        <wps:if loggedIn="true">
        
            <%-- 2. Home --%>
            <wps:popupMenuItem item="2">
                <wps:popupMenuParam param="2">
                    <go href="<wps:url home="protected" />"/>
                </wps:popupMenuParam>
            </wps:popupMenuItem>
            
            <%-- 3. LogOut --%>
            <wps:popupMenuItem item="3">
                <wps:popupMenuParam param="1">
                    <wps:text key="link.logout.wml" bundle="nls.engine"/>
                </wps:popupMenuParam>
                <wps:popupMenuParam param="2">
                    <go href="<wps:url command="LogoutUser" />"/>
                </wps:popupMenuParam>
            </wps:popupMenuItem>
            
            <%-- 4. Mark --%>
<%--   Creating bookmarks is not currently supported in WML
            <wps:popupMenuItem item="4">
                <wps:popupMenuParam param="0">
                    Item4
                </wps:popupMenuParam>
                <wps:popupMenuParam param="1">
                    <wps:text key="link.mark.wml" bundle="nls.engine"/>
                </wps:popupMenuParam>
                <wps:popupMenuParam param="2">
                    <go href="<wps:url command="AddBookmark" alias="wps.favorites"/>"/>
                </wps:popupMenuParam>
            </wps:popupMenuItem>
--%>            
            
            <%-- 5. Bookmark --%>
<%--   Editing bookmarks is not currently supported in WML
            <wps:popupMenuItem item="5">
                <wps:popupMenuParam param="0">
                    Item5
                </wps:popupMenuParam>
                <wps:popupMenuParam param="1">
                    <wps:text key="link.bookmarks.wml" bundle="nls.engine"/>
                </wps:popupMenuParam>
                <wps:popupMenuParam param="2">
                    <go href="<wps:url screen="BookMark" />"/>
                </wps:popupMenuParam>
            </wps:popupMenuItem>
--%>            
                
        </wps:if>

        <%-- generate the markup for the menu here --%>
        <wps:if notScreen="Login">
            <wps:popupMenu />
        </wps:if>
        <%-- individual screens and portlets can redefine the menu items and then regenerate the menu markup in the card --%>

    </template>
    
    <wps:screenRender/>
</wml>
