/*==================================================================
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2002.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *===============================================================*/
package com.ibm.portal.struts.example.fileupload.actions;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.commons.beanutils.PropertyUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Simple Menu Action class to return the success ActionForward
 */
public class MenuAction extends Action
{
	/** The <code>Log</code> instance for this application. */
	private static Log log = 
            LogFactory.getLog (MenuAction.class);

	public ActionForward execute(ActionMapping mapping, 
                                ActionForm form, 
                                HttpServletRequest request, 
                                HttpServletResponse response) throws Exception
	{
		try
		{
         String message = (String) PropertyUtils.getSimpleProperty(form, "message");
         log.debug("message is " + message );
         request.setAttribute( "menuBean", form );

			return mapping.findForward("success");
		}
		catch (Throwable e)
		{
			e.printStackTrace();
			request.setAttribute("exception", e);
			return mapping.findForward("errorBody");
		}
	}
}
