/*==================================================================
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2002.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *===============================================================*/
package com.ibm.portal.struts.example.tiles;

import org.apache.struts.action.ActionForm;

import java.util.Collection;
import java.util.Vector;

/**
 * AccountsBean
 */
public class AccountsBean extends ActionForm
{
    /** The account name */
    protected Collection accounts;

    /**
     * Get the account name
     *
     * @return String the account name
     */
    public Collection getAccounts() 
    {
        return accounts;
    }

    /**
     * add the account
     *
     * @param AccountBean the account
     */
    public void addAccount( AccountBean accountBean) 
    {
       if (accounts == null )
       {
          accounts = new Vector();
       }
       accounts.add( accountBean );
    }

    /**
     * Reset - remove all account information
     */
    public void reset()
    {
       accounts = null;
       accounts = new Vector();
    }

}
