/*==================================================================
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2002.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *===============================================================*/
package com.ibm.portal.struts.example.tiles.actions;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.tiles.Controller;
import org.apache.struts.tiles.ComponentContext;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletException;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletResponse;

/**
 * This is a simple example of a controller. The controller is 
 * invoked before the tiles are inserted. Setup for the page can
 * be executed in this class.
 */
public class SetupController implements Controller 
{
   /**
     * The <code>Log</code> instance for this application.
     */
   private static Log log = LogFactory.getLog(SetupController.class);
   
   public void perform(ComponentContext tileContext,
                       HttpServletRequest request, 
                       HttpServletResponse response,
                       ServletContext servletContext)
        throws ServletException, IOException
   {
      log.debug("This is from the Setup Controller");
      Object obj = request.getAttribute("setup");
      if ( obj == null )
      {
         request.setAttribute("setup","setup controller was called");
      }
      else
      {
         request.setAttribute("setup","setup controller called more than once");
      }
   }
}
