/*********************************************************************
 * Licensed Materials - PropertyImpl of IBM                              *
 *                                                                   *
 * 5724-B88                                                          *
 *                                                                   *
 *  Copyright IBM Corp.  2001, 2002    All Rights Reserved.         *
 *                                                                   *
 * US Government Users Restricted Rights - Use, duplication or       *
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp. *
 *********************************************************************/

package com.ibm.websphere.query.base;

/**
	<P>The IFunction interface is an object that represents a function in a query. 
	
	<P>It extends the ILeftOperand, IRightOperand, IOrderByElement, IFunctionElement, and 
	IStringBuilder interfaces. 
	
	<P>Instances of classes that implement this interface are used to represent functions that
	contain a name and function elements.
 */
public interface IFunction extends ILeftOperand, IRightOperand, IOrderByElement, IFunctionElement, IStringBuilder
{
  /**
  	Returns the function elements of the function.
   */
  IFunctionElement[] getFunctionElements();
  /**
  	Returns the name of the function.
   */
  String getName();
}