/*********************************************************************
 * Licensed Materials - PropertyImpl of IBM                              *
 *                                                                   *
 * 5724-B88                                                          *
 *                                                                   *
 *  Copyright IBM Corp.  2001, 2002    All Rights Reserved.         *
 *                                                                   *
 * US Government Users Restricted Rights - Use, duplication or       *
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp. *
 *********************************************************************/

package com.ibm.websphere.query.base;


/**
	<P>The ISelectStringBuilder interface provides external interfaces to predicate and order by 
	query string generation that utilizes domain specific builder callbacks.
	
	<P>ISelectStringBuilder extends the IStringBuilder interface. 
	
	<P>A class implements this interface to indicate that the instances of that class can produce 
	a predicate string and an order by string by means of interfacing with a builder callback.
 */
public interface ISelectStringBuilder extends IStringBuilder
{

  /**
  	Builds an order by string using the given builder callback.
  */
  void buildOrderByString(ISelectQueryCallback builder, StringBuffer sb) throws QueryException;
  /**
  	Builds a predicate string using the given builder callback.
  */
  void buildPredicateString(ISelectQueryCallback builder, StringBuffer sb) throws QueryException;

}
