/*********************************************************************
 * Licensed Materials - PropertyImpl of IBM                              *
 *                                                                   *
 * 5724-B88                                                          *
 *                                                                   *
 *  Copyright IBM Corp.  2001, 2002    All Rights Reserved.         *
 *                                                                   *
 * US Government Users Restricted Rights - Use, duplication or       *
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp. *
 *********************************************************************/

package com.ibm.websphere.query.base;

/**
	<P>The IValue interface is an object that represents a value in a query. 
	
	<P>It extends the ILeftOperand, IRightOperand, IFunctionElement, and IStringBuilder interfaces.
	
	<P>Instances of classes that implement this interface are used to represent values that contain
	a value string and a data type.
 */
public interface IValue extends ILeftOperand, IRightOperand, IFunctionElement, IStringBuilder
{
  /**
  	Returns the value string of the value.
   */
  String getValueString();

  String getPropertyName();
}