/* @copyright module */
/*                                                                            */
/*  DISCLAIMER OF WARRANTIES:                                                 */
/*  -------------------------                                                 */
/*  The following [enclosed] code is sample code created by IBM Corporation.  */
/*  This sample code is provided to you solely for the purpose of assisting   */
/*  you in the development of your applications.                              */
/*  The code is provided "AS IS", without warranty of any kind. IBM shall     */
/*  not be liable for any damages arising out of your use of the sample code, */
/*  even if they have been advised of the possibility of such damages.        */
package com.ibm.etools.portal.portletexamples.cooperative.legacy;

public class TrackingDetail implements Dumpable {

    private String trackingId;
    private String status;
    private String customerName;
    private String destination;
    private RouteSegment[] routeSegments;

    public TrackingDetail(String trackingId, String status, String customerName, String destination, RouteSegment[] routeSegments) {
        this.trackingId = trackingId;
        this.status = status;
        this.customerName = customerName;
        this.destination = destination;
        this.routeSegments = routeSegments;
    }
    
    public String getTrackingId() {
        return trackingId;
    }

    public String getStatus() {
        return status;
    }

    public String getCustomerName() {
        return customerName;
    }

    public String getDestination() {
        return destination;
    }

    public RouteSegment[] getRouteSegments() {
        return routeSegments;
    }

    public void dump() {
        System.out.println("Tracking id = " + trackingId);
        System.out.println("Status = " + status);
        System.out.println("Customer name = " + customerName);
        System.out.println("Destination = " + destination);
	if (routeSegments != null) {
	    for (int i = 0; i < routeSegments.length; i++) {
	        System.out.println("Route segment " + i + " = ");
		routeSegments[i].dump();
	    }
	}
    }
}
