
// This global variable serves as a flag for RTE acessibility support.
// This var is set in options_ie.jsp when the accessible toolbar is invoked.
var isAccessible = false;

// This global variable is used to transfer the editor content from the main 
// editor window to the child print window. 
// This var is added in 5.1 release. See IBM_RTE_doPrint() for details. 
var cnt;

function IBM_RTE_isMozilla() {
    return navigator.product == 'Gecko';
}

function IBM_RTE_getFrame(editorName) {
    if (!isAccessible)
       return document.getElementById(editorName );
    else
       return this.opener.document.getElementById(editorName );      
}

function IBM_RTE_getWindow(editorName) {
    return IBM_RTE_getFrame(editorName).contentWindow;
}

function IBM_RTE_getDocument(editorName) {
    return IBM_RTE_getWindow(editorName).document;
}

function IBM_RTE_setDesignMode1(editorName) {
    IBM_RTE_getDocument(editorName).designMode = "on";  

}


//In IE, use body.contentEditable to set the document to be editable.
//This allows elements to be hidden or shown as needed using style.display attribute.
//The change is mainly for 5.1 annotation feature (available in the popup editor version only).
//No existing features are affected by this change.
function IBM_RTE_setDesignMode(editorName) {
    if (IBM_RTE_isMozilla()) {
        IBM_RTE_getDocument(editorName).designMode = "on";  
    }
    else {

		if ((IBM_RTE_getDocument(editorName).body)==null)
		{
			setTimeout("IBM_RTE_setDesignMode('" + editorName + "')", 1500);
        
		}
		else
		{
			IBM_RTE_getDocument(editorName).body.contentEditable = true;
		}
    }
}


function IBM_RTE_getToolbarColor(editorName) {
    return IBM_RTE_isMozilla() ? document.defaultView.getComputedStyle(document.getElementById(editorName), '').getPropertyValue("background-color") : document.getElementById(editorName).currentStyle.backgroundColor;
}

function IBM_RTE_loadEditorWithEmptyDocument(editorName, docDir) {
    IBM_RTE_getDocument(editorName).body.innerHTML = "<html><head><title></title></head><body dir='" + docDir + "'></body></html>";
}

function IBM_RTE_doTheCommand(editorName, commandname) {        
    IBM_RTE_getWindow(editorName).focus();
    IBM_RTE_getDocument(editorName).execCommand(commandname, false, null);
}

function IBM_RTE_doLink(editorName, prompttext) {    
    if (IBM_RTE_isMozilla()) {
        var theurl = prompt(prompttext, "http://");
        IBM_RTE_getDocument(editorName).execCommand('createlink', false, theurl);
    }
    else {
        IBM_RTE_getWindow(editorName).focus();
        IBM_RTE_getDocument(editorName).execCommand('createlink', true, null);
    }
}

function IBM_RTE_doFontStyle(editorName, ctrl, commandname) {

    if (ctrl) {
        var hType = ctrl.options[ctrl.selectedIndex].value;

        if (!isAccessible)
            ctrl.selectedIndex = 0;

        if (hType != '') {
            IBM_RTE_getWindow(editorName).focus();
            IBM_RTE_getDocument(editorName).execCommand(commandname, false, hType);
    }}
}

function IBM_RTE_getOffsetTop(ctrl) {

    var offsetTop = ctrl.offsetTop;
    var offsetParent = ctrl.offsetParent;

    while (offsetParent) {            
        offsetTop += offsetParent.offsetTop;
        offsetParent = offsetParent.offsetParent;
    }

    return offsetTop;
}

function IBM_RTE_getOffsetLeft(ctrl) {

    var offsetLeft = ctrl.offsetLeft;
    var offsetParent = ctrl.offsetParent;

    while (offsetParent) {
        offsetLeft += offsetParent.offsetLeft;
        offsetParent = offsetParent.offsetParent;
    }

    return offsetLeft;
}

function IBM_RTE_doColor(editorName, clrType, buttonElement, locale, images, directory, isBidi) {

    if (IBM_RTE_isMozilla()) {
        if (clrType.localeCompare("backcolor") == 0) 
             clrType = "hilitecolor"; 
    }

    //document.getElementById(editorName + "_color").value = clrType;
/*
    var jrl = "colors_ie.jsp";
    jrl = directory + jrl;
    var wcp_colorWin = window.open(jrl + '?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi  + '&clrType=' + clrType, 'colors', 'scrollbars=0, toolbar=0, statusbar=0, width=260, height=150, left=' + ((screen.width - 260) / 2) + ', top=' + ((screen.height - 150) / 2));
    wcp_colorWin.focus();
*/
	IBM_RTE_getWindow(editorName).focus();
    var jrl = "colorPicker_accessible.jsp";
    jrl = directory + jrl;
    var wcp_colorWin = window.open(jrl + '?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi  + '&clrType=' + clrType, 'colors', 'scrollbars=0, toolbar=0, statusbar=0, width=320, height=450, left=' + ((screen.width - 260) / 2) + ', top=' + ((screen.height - 150) / 2));
    wcp_colorWin.focus();

}



// Used to insert elements in Mozilla editor.
function IBM_RTE_insertNodeAtSelection(win, insertNode) {
  
    // get current selection
    var sel = win.getSelection();

    // get the first range of the selection
    // (there's almost always only one range)
    var range = sel.getRangeAt(0);

    // deselect everything
    sel.removeAllRanges();

    // remove content of current selection from document
    range.deleteContents();

    // get location of current selection
    var container = range.startContainer;
    var pos = range.startOffset;

    // make a new range for the new selection
    range = document.createRange();

    if (container.nodeType == 3 && insertNode.nodeType == 3) {
    
        // if we insert text in a textnode, do optimized insertion
        container.insertData(pos, insertNode.nodeValue);
        
        // put cursor after inserted text
        range.setEnd(container, pos + insertNode.length);
        range.setStart(container, pos + insertNode.length);        
    }
    else {
        
        var afterNode;
        if (container.nodeType == 3) {

            // when inserting into a textnode
            // we create 2 new textnodes
            // and put the insertNode in between

            var textNode = container;
            container = textNode.parentNode;
            var text = textNode.nodeValue;

            // text before the split
            var textBefore = text.substr(0,pos);
            // text after the split
            var textAfter = text.substr(pos);
            
            var beforeNode = document.createTextNode(textBefore);
            var afterNode = document.createTextNode(textAfter);
            
            // insert the 3 new nodes before the old one
            container.insertBefore(afterNode, textNode);
            container.insertBefore(insertNode, afterNode);
            container.insertBefore(beforeNode, insertNode);
            
            // remove the old node
            container.removeChild(textNode);
        }
        else {

            // else simply insert the node
            afterNode = container.childNodes[pos];
            container.insertBefore(insertNode, afterNode);
        }

        range.setEnd(afterNode, 0);
        range.setStart(afterNode, 0);
    }

    sel.addRange(range);
}

function IBM_RTE_doTableInsert(editorName, buttonElement, locale, images, directory, numrows, numcols, isBidi) {

    IBM_RTE_getWindow(editorName).focus();
    var wcp_tableWin = window.open(directory + 'table_ie.jsp?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, 'table', 'scrollbars=0, toolbar=0, statusbar=0,resizable=yes, width=200, height=190, left=' + ((screen.width - 200) / 2) + ', top=' + ((screen.height - 170) / 2));
    wcp_tableWin.focus();
}

function IBM_RTE_getEditorHTML(editorName) {

    var bodyDir =  IBM_RTE_getDocument(editorName).body.dir;

    var lnks = IBM_RTE_getDocument(editorName).getElementsByTagName("link");

    var iHead = '<html>\n<head>\n<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />\n';
    var ttls = IBM_RTE_getDocument(editorName).getElementsByTagName("title");
    if ((ttls) && ttls.length > 0) {
        iHead += "<title>" + ttls[0].text + "</title>\n";
    }
    
    for (i = 0; (lnks) && (i < lnks.length); i++) {
        iHead += "<link rel='" + lnks[0].rel + "' href='" + lnks[i].href + "' />\n";
    }

    iHead += "</head>\n";

    if (bodyDir.localeCompare('ltr') == 0)
        iHead += "<body dir='ltr'>\n";
    else if (bodyDir.localeCompare('rtl') == 0) 
        iHead += "<body dir='rtl'>\n";
    else
        iHead += "<body>\n";

    iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    iFoot = "</body>\n</html>";

    iAll = iHead + iHTML + iFoot;

    return iAll;
}


function IBM_RTE_getEditorContent(editorName, mode,encoding) {
	

    var bodyDir =  IBM_RTE_getDocument(editorName).body.dir;

    var lnks = IBM_RTE_getDocument(editorName).getElementsByTagName("link");

    var iHead = '<html>\n<head>\n<meta http-equiv="content-type" content="text/html; charset="+encoding+" />\n';
    var ttls = IBM_RTE_getDocument(editorName).getElementsByTagName("title");
    if ((ttls) && ttls.length > 0) {
        iHead += "<title>" + ttls[0].text + "</title>\n";
    }
    
    for (i = 0; (lnks) && (i < lnks.length); i++) {
        iHead += "<link rel='" + lnks[0].rel + "' href='" + lnks[i].href + "' />\n";
    }

    iHead += "</head>\n";

    if (bodyDir.localeCompare('ltr') == 0)
        iHead += "<body dir='ltr'>\n";
    else if (bodyDir.localeCompare('rtl') == 0) 
        iHead += "<body dir='rtl'>\n";
    else
        iHead += "<body>\n";


    if (mode == 0){
                 iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
		 IBM_RTE_getDocument(editorName).body.innerText = iHTML;
		 iText = IBM_RTE_getDocument(editorName).body.innerText;
		 IBM_RTE_getDocument(editorName).body.innerHTML = iText;
       iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    }
    else if (mode == 1) {
         if (IBM_RTE_isMozilla()) {
            var html = IBM_RTE_getDocument(editorName).body.ownerDocument.createRange();
            html.selectNodeContents(IBM_RTE_getDocument(editorName).body);
            iHTML = html.toString();
         }
         else {
            iHTML = IBM_RTE_getDocument(editorName).body.innerText;
         }
    }      

    iFoot = "</body>\n</html>";

	iHTML= iHTML.replace(/\<TD\>\<\/TD\>/g, "<TD>&nbsp;</TD>");
    iAll = iHead + iHTML + iFoot;

    return iAll;
}


function IBM_RTE_getEditorHTML2(editorName, metaCnt) {

    var bodyDir =  IBM_RTE_getDocument(editorName).body.dir;

    var lnks = IBM_RTE_getDocument(editorName).getElementsByTagName("link");

    var iHead = '<html>\n<head>\n';
    iHead += '<meta http-equiv="content-type" content="' + metaCnt + '" />\n';

    var ttls = IBM_RTE_getDocument(editorName).getElementsByTagName("title");
    if ((ttls) && ttls.length > 0) {
        iHead += "<title>" + ttls[0].text + "</title>\n";
    }
    
    for (i = 0; (lnks) && (i < lnks.length); i++) {
        iHead += "<link rel='" + lnks[0].rel + "' href='" + lnks[i].href + "' />\n";
    }

    iHead += "</head>\n";

    if (bodyDir.localeCompare('ltr') == 0)
        iHead += "<body dir='ltr'>\n";
    else if (bodyDir.localeCompare('rtl') == 0) 
        iHead += "<body dir='rtl'>\n";
    else
        iHead += "<body>\n";

    iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    iFoot = "</body>\n</html>";

    iAll = iHead + iHTML + iFoot;

    return iAll;
}


function IBM_RTE_getEditorHTMLFragment(editorName) {

    return IBM_RTE_getDocument(editorName).body.innerHTML;
}

function IBM_RTE_setEditorHTML(editorName, content) {
    IBM_RTE_getDocument(editorName).body.innerHTML = content;
}

function IBM_RTE_encodeHTML(str) {

	if (!str) return '';
	if (typeof(str) != 'string') str = str.toString();

	str = str.replace( /&/g, '&amp;' );
	str = str.replace( /</g, '&lt;' );
	str = str.replace( />/g, '&gt;' );
	str = str.replace( /"/g, '&quot;' );

	return str;
}

function IBM_RTE_flipDocument(editorName, prompttext) {

    var origDir =  IBM_RTE_getDocument(editorName).body.dir;

    if ((origDir.localeCompare('') == 0)||(origDir.localeCompare('ltr') == 0))
        IBM_RTE_getDocument(editorName).body.dir = "rtl";
    else if (origDir.localeCompare('rtl') == 0)
        IBM_RTE_getDocument(editorName).body.dir = "ltr";

    IBM_RTE_getWindow(editorName).focus();

}


function IBM_RTE_getSelectionRange(editorName)
{
      var doc = IBM_RTE_getDocument(editorName);
      var win = IBM_RTE_getWindow(editorName);

	var ret = null; 
	if(doc.selection)
		ret = doc.selection.createRange();
	else if (win.getSelection)
	{
		var sel = win.getSelection();
		if(sel != null && sel.rangeCount > 0)
			ret = sel.getRangeAt(0);
	}
	return ret;
}


// TODO: detect and clean up redundant DIR tags while preserving other tags.

// Mozilla has no good way to insert a new node to subsume the selection content 
// other than using surroundContents(). SurroundContents() is not very tolerant in
// the selection, such as if the Range partially selects a non-Text node, 
// surroundContents() raises an exception.
// Using separate operations extractContents(), insertNode() will NOT help, it would
// only make things worse, as when insertNode() throws exception, the range content 
// has been removed already. Using surroundContents(), when it throws exception, the 
// range content will remain unchanged.
//
// May need to find a way to mimic IE's behavior???

function IBM_RTE_flipSelection(editorName, prompttext, dir) {

    // Get a selection range.
    var rng = IBM_RTE_getSelectionRange(editorName);
    
    if (IBM_RTE_isMozilla()) {

        if (rng) {

            var doc = IBM_RTE_getDocument(editorName);
  
            var newParent = doc.createElement("div");
            newParent.setAttribute("dir", dir);

            //rng.surroundContents(newParent);

			newParent.appendChild(rng.extractContents());
			rng.insertNode(newParent);
        }
    }
    else {
        if (rng) {
		var newParent;

            
			var tert=rng.htmlText;
			var tert1=tert.substring(2,10);

		

		
		//if(tert1=="<DIV dir")
			if(rng.parentElement().tagName=="DIV")
			{
				
				tert="<DIV dir='"+dir+"'>"+tert.substring(15,tert.length);	
				
					rng.parentElement().getAttributeNode("dir").value=dir;


				var childdiv1=rng.parentElement().getElementsByTagName("DIV");

					if(childdiv1.length>0)
					{

						

						for (i = 0; i<childdiv1.length; i++)
											{
							
							childdiv1[i].getAttributeNode("dir").value=dir;
											 
											}

						
						


					}

				

			}
			else
			{

					
					 var childdiv=rng.parentElement().getElementsByTagName("DIV");
								   //var childdiv=rng.parentElement().childNodes;
					//alert(rng.parentElement().childNodes);

					if(childdiv.length>0)
					{


								

						for (i = 0; i<childdiv.length; i++)
											{
							
							//alert("tagname"+rng.parentElement().childNodes[i].tagName);
							//childdiv[i].getAttributeNode("dir").value=dir;
							  //childdiv[i].createAttribute("dir");

							//if(childdiv[i].nodeType==1)
							//{
								
								
								childdiv[i].getAttributeNode("dir").value=dir;
								
												//}
											}

						
						


					}
						
					
						newParent = IBM_RTE_getDocument(editorName).createElement("DIV DIR='" + dir + "'");
						//rng=IBM_RTE_getSelectionRange(editorName);
									newParent.innerHTML = rng.htmlText;
						
							rng.pasteHTML(newParent.outerHTML);
					

			}
		
	      
        }
    }

    IBM_RTE_getWindow(editorName).focus();
}


function IBM_RTE_checkEvent(editorName) {

   if (typeof checkEvent != 'undefined') {
       checkEvent();
    }
    
}


// These three functions are actually used in dialogs to highlight 
// buttons when mouse is moved over. Use document instead of 
// IBM_RTE_getDocument() because dialogs are in their own windows.
function setStyle(element, name, value) {
        if (element.style && (element.style[name] != value) )
            element.style[name] = value;
}

function IBM_RTE_btn_mouseover(id) {
        
        var elmt = document.getElementById(id);

        if (elmt) {
            setStyle(elmt, 'color', '#0000FF');
            setStyle(elmt, 'borderColor', '#0000FF');
        }
}

function IBM_RTE_btn_mouseoout(id) {
        
        var elmt = document.getElementById(id);

        if (elmt) {
            setStyle(elmt, 'color', '#405380');
            setStyle(elmt, 'borderColor', '#405380');
        }
}


function IBM_RTE_setATag(editorName) {

        var aTags = IBM_RTE_getDocument(editorName).body.getElementsByTagName("A");
        var len = aTags.length;
        for (var i=0; i < len; i++) {
            var aLink = aTags[i].href;
            if (aLink.substring(0, 5) == "http:") {
                aTags[i].target = "_blank";
            }
            else if (aLink.substring(0, 6) == "https:") {
                aTags[i].target = "_blank";
            }
            else if (aLink.substring(0, 4) == "ftp:") {
                aTags[i].target = "_blank";
            }
            else if (aLink.substring(0, 5) == "file:") {
                aTags[i].target = "_blank";
            }
        }
}








// The following functions are for advanced table support.
// Added in 5.1 release.


//This is a utility function to return the current row where the cursor is.
function IBM_RTE_getCurrentRow(editorName) {

    var selRange = IBM_RTE_getSelectionRange(editorName);
    var currentRow;

    if (IBM_RTE_isMozilla()) {
        currentRow = selRange.startContainer;
        var strName = currentRow.nodeName;
         
        while(strName != "TR") {
            currentRow = currentRow.parentNode;
            if (currentRow == null) break;
            strName = currentRow.nodeName;
        }
    }
    else {
        currentRow = selRange.parentElement();
        var strName = currentRow.tagName;
        
        while(strName != "TR") {
            currentRow = currentRow.parentNode;
            if (currentRow == null) break;
            strName = currentRow.tagName;
        }
    }
 
    return currentRow;
}

//This is a utility function to return the number of cells in one row.
//Nested table in a row is considered as one cell. 
function IBM_RTE_getNumOfCells(editorName) {
   var currentRow = IBM_RTE_getCurrentRow(editorName);

   var cells = currentRow.getElementsByTagName("TD");

   // Can not return cells.length directly because if there is
   // a sub-table embedded, the cells.length will include the sub 
   // table cells. Using nextSibling can slove this issue. 
   // See below.

   // return cells.length;
   
   var j=0;
   if (cells.length > 0) {
      var cellNode = cells[0];

      if (IBM_RTE_isMozilla()) {
        for (;;) {
           if (cellNode!=null && cellNode.nodeName == "TD"){
              j++;
              cellNode = cellNode.nextSibling;     
           }else {
              break;
           }
        }
      }
      else {
        for (;;) {
           if (cellNode!=null && cellNode.tagName == "TD"){
              j++;
              cellNode = cellNode.nextSibling;     
           }else {
              break;
           }
        }
      }
   }

   return j;
}

//Utility function to create a new cell.
//In Mozilla, <BR> has to be added in each cell.
function IBM_RTE_createNewCell(editorName) {

    // In Mozilla, the new cell needs to add a <br> to a new cell.
    var doc = IBM_RTE_getDocument(editorName);
    var newCell = doc.createElement("TD");

    if (IBM_RTE_isMozilla()) {
        var brElem = doc.createElement("BR");
        newCell.appendChild(brElem);
    }

    return newCell;
}


function IBM_RTE_deleteRow(editorName, text) {

   var ret = confirm(text);
   if (!ret) {
       return;
   }

   var currentRow = IBM_RTE_getCurrentRow(editorName);
   var container = currentRow.parentNode;
   container.removeChild(currentRow);

   //When child nodes in TBODY is 0, delete the whole table.
   if (container.nodeName == "TBODY" && container.childNodes.length == 0){
       var parTable = container.parentNode;
       parTable.parentNode.removeChild(parTable);
   }
}

function IBM_RTE_insertRowAbove(editorName) {

   var currentRow = IBM_RTE_getCurrentRow(editorName);
    if (currentRow == null) return;

   var numOfCells = IBM_RTE_getNumOfCells(editorName);  
   var newRow = IBM_RTE_getDocument(editorName).createElement("TR");

   for (i=0; i<numOfCells; i++) {
       var col = IBM_RTE_createNewCell(editorName);
       newRow.appendChild(col);
   }

   var container = currentRow.parentNode;
   container.insertBefore(newRow, currentRow);
}

function IBM_RTE_insertRowBelow(editorName) {

   var currentRow = IBM_RTE_getCurrentRow(editorName);
    if (currentRow == null) return;

   var numOfCells = IBM_RTE_getNumOfCells(editorName);  
   var newRow = IBM_RTE_getDocument(editorName).createElement("TR");

   for (i=0; i<numOfCells; i++) {
       var col = IBM_RTE_createNewCell(editorName);
       newRow.appendChild(col);
   }

   var container = currentRow.parentNode;
   var prevRow = currentRow.nextSibling;
   container.insertBefore(newRow, prevRow);
}


//Utility function to return the cellIndex in the current row. 
// Cell index starts from 0.
function IBM_RTE_getColumnIndex(editorName) {

    var selRange = IBM_RTE_getSelectionRange(editorName);
    var currentCell;

   if (IBM_RTE_isMozilla()) {
        currentCell = selRange.startContainer;
        var strName = currentCell.nodeName;

        while(strName != "TD") {
            currentCell = currentCell.parentNode;
            if (currentCell == null) return null;
            strName = currentCell.nodeName;
        }
    } 
    else {
        currentCell = selRange.parentElement();
        var strName = currentCell.tagName;

        while(strName != "TD") {
            currentCell = currentCell.parentNode;
            if (currentCell == null) return null;
            strName = currentCell.tagName;
        }
    }

    return currentCell.cellIndex;
}

//Utility function to return the current table.
function IBM_RTE_getTable(editorName) {
    var currRow = IBM_RTE_getCurrentRow(editorName);
    if (currRow == null) return null;
    var currTable;

    if (IBM_RTE_isMozilla()) {  
        currTable = currRow.parentNode.parentNode;
    }
    else {
        currTable = currRow.parentNode;
        var strName = currTable.tagName;

        while(strName != "TABLE") {
            currTable = currTable.parentNode;
            strName = currTable.tagName;
        }
    }
   
    return currTable;
}


function IBM_RTE_deleteColumn(editorName, text) {

    var ret = confirm(text);
    if (!ret) {
        return;
    }

    var currColIndex = IBM_RTE_getColumnIndex(editorName);
    var currTable = IBM_RTE_getTable(editorName);
    if (currTable == null) return;

    var rows = currTable.rows;
    var numOfRows = rows.length

    for (i=0; i<numOfRows; i++) {
        var rowElement = rows[i];
        if (rowElement.cells.length > currColIndex) {
            var cellNode = rowElement.cells[currColIndex];
            rowElement.removeChild(cellNode);
        }
    }

    if (rows[0].cells.length == 0) {
            // When a row has no cell, delete the whole table;
            var parNode = currTable.parentNode;
            parNode.removeChild(currTable);
    }
}


function IBM_RTE_insertColumn(isLeft, editorName) {

    var currColIndex = IBM_RTE_getColumnIndex(editorName);
    var currTable = IBM_RTE_getTable(editorName);
    if (currTable == null) return;

    var rows = currTable.rows;
    var numOfRows = rows.length;

    for (i=0; i<numOfRows; i++) {
        var rowElement = rows[i];
        if (rowElement.cells.length > currColIndex) {          
           var cellNode = rowElement.cells[currColIndex];
           var newCell = IBM_RTE_createNewCell(editorName);

           if (isLeft) {
               rowElement.insertBefore(newCell, cellNode);
           }
           else {
               if (rowElement.cells.length == currColIndex + 1) {
                   rowElement.appendChild(newCell);
               }
               else {
                   cellNode = rowElement.cells[currColIndex + 1];
                   rowElement.insertBefore(newCell, cellNode);
               }
           }
        }
    } //End of for loop.
}


function IBM_RTE_insertColumnLeft(editorName) {

    IBM_RTE_insertColumn(true, editorName); 
}

function IBM_RTE_insertColumnRight(editorName) {

    IBM_RTE_insertColumn(false, editorName); 
}



// In IE, when move from one op to another, the selRange.parentElement 
// becomes BODY for the second op. You have to reselect a cell using 
// mouse or keyboard. This seems like an IE bug. 
// Mozilla does not have this problem. 
// The following two functions are to prove this.
function IBM_RTE_insertColumnLeft1(editorName) {

    var selRange = IBM_RTE_getSelectionRange(editorName);
    alert(selRange.parentElement().tagName);
}

function IBM_RTE_insertColumnRight1(editorName) {
    var selRange = IBM_RTE_getSelectionRange(editorName);
    alert(selRange.parentElement().tagName);
}

//Other issues with the advanced table support:
// 1. After delete a row/column, the selection goes away. This makes sense.
// 2. Undo/redo does not take effect since these new functions are DOM manipulation.



function IBM_RTE_insertPageBreak(editorName){

    var rand = Math.round(Math.random()*100000000000000000);
    var pageBreakID = "pagebreak_"+rand;

    var rng = IBM_RTE_getSelectionRange(editorName);

    newNode = IBM_RTE_getDocument(editorName).createElement("div");

    if (IBM_RTE_isMozilla()) {  
        //Since Mozilla does not support contentEditable attribute, 
        //per M. Kaply's suggestion, use <HR> as the page break indicator.
        //newNode.appendChild(IBM_RTE_getDocument(editorName).createTextNode("-------- page break --------"));
        //newNode.style.MozUserSelect = "none";
        //newNode.style.MozUserInput = "none";
        //newNode.style.MozUserFocus = "none";
        //newNode.style.MozUserModify = "ready-only";

        newNode.setAttribute("id", pageBreakID);
        newNode.setAttribute("align", "center");
        var newChild = IBM_RTE_getDocument(editorName).createElement("HR");
        newNode.appendChild(newChild);
        newNode.style.pageBreakBefore = "always";

        //Use Koranteng's insertNodeIntoRange() utility function to insert the pagebreak node.
        rng.deleteContents();
        var container = rng.startContainer;
        var pos = rng.startOffset;

        var afterNode = null;
        if (container.nodeType == 3) {
		// when inserting into a textnode
		// we create 2 new textnodes
		// and put the insertNode in between
            var textNode = container;
            container = textNode.parentNode;
            var text = textNode.nodeValue;

		// split the text
            var textBefore = text.substr(0, pos);
            var textAfter = text.substr(pos);

            var beforeNode = IBM_RTE_getDocument(editorName).createTextNode(textBefore);
            afterNode = IBM_RTE_getDocument(editorName).createTextNode(textAfter);

		// insert the 3 new nodes before the old one
            container.insertBefore(afterNode, textNode);
            container.insertBefore(newNode, afterNode);
            container.insertBefore(beforeNode, newNode);

            // remove the old node
		container.removeChild(textNode);
        }
        else {
		// else simply insert the node
            // Somehow, after the new node is inserted, the rest of the container is selected and 
            // deselecting everyting does not seem to work. Mozilla problem ???
		afterNode = container.childNodes[pos];
		container.insertBefore(newNode, afterNode);
        }
	  if(afterNode != null) {
		rng.setEnd(afterNode, 0);
		rng.setStart(afterNode, 0);
      	// deselect everything
	      // rng.removeAllRanges();
	  }       
    }
    else {
        newNode.id = pageBreakID;
        newNode.align = "center";
        newNode.innerText = "------------ Page Break ------------";
        newNode.contentEditable = false;
        newNode.disabled = true;
        rng.pasteHTML(newNode.outerHTML);

        //It is strange that I can't set the pagebreak style before it is inserted.
        var pbNode = IBM_RTE_getDocument(editorName).getElementById(pageBreakID);
        pbNode.style.pageBreakBefore = "always";
    }
}



// When pagebreak indicators are inserted, a new getEditorContent will be 
// needed to remove the indicators for print.

function IBM_RTE_getEditorContentPrint(editorName, mode) {

    var text = "";
   
    var divNodes = IBM_RTE_getDocument(editorName).getElementsByTagName("div");

    if (IBM_RTE_isMozilla()) {  
        for(i=0; i<divNodes.length; i++) {
            if (divNodes[i].id.substring(0, 10) == "pagebreak_") {
                var childNode = divNodes[i].childNodes[0];
                divNodes[i].removeChild(childNode);
            }       
        }
    }
    else {
        for(i=0; i<divNodes.length; i++) {
            if (divNodes[i].id.substring(0, 10) == "pagebreak_") {
                text = divNodes[i].innerText;
                divNodes[i].innerText = "";
            }
        }
    }


    var editorCnt = IBM_RTE_getEditorContentPrint2(editorName, mode);  


    if (IBM_RTE_isMozilla()) {  
        for(i=0; i<divNodes.length; i++) {
            if (divNodes[i].id.substring(0, 10) == "pagebreak_") {
                var newChild = IBM_RTE_getDocument(editorName).createElement("HR");
                divNodes[i].appendChild(newChild);
            }       
        }
    }
    else {
        for(i=0; i<divNodes.length; i++) {
            if (divNodes[i].id.substring(0, 10) == "pagebreak_") {
                divNodes[i].innerText = text;
            }
        }
    }

    return editorCnt;
}

function IBM_RTE_getEditorContentPrint2(editorName, mode) {

    if (mode == 0){
                 iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
		 IBM_RTE_getDocument(editorName).body.innerText = iHTML;
		 iText = IBM_RTE_getDocument(editorName).body.innerText;
		 IBM_RTE_getDocument(editorName).body.innerHTML = iText;
       iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    }
    else if (mode == 1) {
         if (IBM_RTE_isMozilla()) {
            var html = IBM_RTE_getDocument(editorName).body.ownerDocument.createRange();
            html.selectNodeContents(IBM_RTE_getDocument(editorName).body);
            iHTML = html.toString();
         }
         else {
            iHTML = IBM_RTE_getDocument(editorName).body.innerText;
         }
    }      

    return iHTML;
}

function IBM_RTE_doPrint(editorName, fileName) {
   
    cnt = IBM_RTE_getEditorContentPrint(editorName, 0);

    var win = window.open(fileName, "printPreview", "width=600,height=400,menubar=yes,location=no");

/*
    IBM_RTE_getWindow(editorName).focus();
    IBM_RTE_getWindow(editorName).print();
*/
}



function IBM_RTE_paraSupport(editorName, buttonElement, locale, images, directory, isBidi){
    IBM_RTE_getWindow(editorName).focus();

    // calculate the position for the dialog relative to the parent window
    var winx = IBM_RTE_isMozilla() ? window.screenX : window.screenLeft;
    var winy = IBM_RTE_isMozilla() ? window.screenY : window.screenTop;
    var winw = IBM_RTE_isMozilla() ? window.innerWidth : IBM_RTE_getDocument(editorName).body.offsetWidth;
    var winh = IBM_RTE_isMozilla() ? window.innerHeight: IBM_RTE_getDocument(editorName).body.offsetHeight;

    var w = 330;
    var h = 330;
    var x = (winw-w)/2+winx;
    var y = (winh-h)/2+winy;

    var rand = Math.round(Math.random()*100000000000000000);
    var winID = "paraSupport_"+rand;

    var flags = "screenX="+x+",screenY="+y+",left="+x+",top="+y+",width="+w+",height="+h+",resizable=yes,status=no,scrollbars=no,dependent=yes,modal=yes";

    
	var paraWin = window.open(directory + 'paraSupport.jsp?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, winID, flags);
    paraWin.focus();
}



function IBM_RTE_findReplace(editorName, buttonElement, locale, images, directory, isBidi){
    IBM_RTE_getWindow(editorName).focus();

    // calculate the position for the dialog relative to the parent window
    var winx = IBM_RTE_isMozilla() ? window.screenX : window.screenLeft;
    var winy = IBM_RTE_isMozilla() ? window.screenY : window.screenTop;
    var winw = IBM_RTE_isMozilla() ? window.innerWidth : IBM_RTE_getDocument(editorName).body.offsetWidth;
    var winh = IBM_RTE_isMozilla() ? window.innerHeight: IBM_RTE_getDocument(editorName).body.offsetHeight;

    var w = 450;
    var h = 230;
    var x = (winw-w)/2+winx;
    var y = (winh-h)/2+winy;

    var rand = Math.round(Math.random()*100000000000000000);
    var winID = "FindReplace_"+rand;

    var flags = "screenX="+x+",screenY="+y+",left="+x+",top="+y+",width="+w+",height="+h+",resizable=yes,status=no,scrollbars=no,dependent=yes,modal=yes";
//    window.open("findReplace.jsp", winID, flags);


	var findReplWin = window.open(directory + 'findReplace.jsp?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, winID, flags);
    findReplWin.focus();
}


//I don't like this way of restoring comments in Mozilla. It is a hack, 
//not a solution. However, since Mozilla currently does not support contentEditable
//attribute, we probably have to use Mozilla properrietary technologies to mimic IE 
//functions.

function IBM_RTE_MozillaRestoreComments(editorName) {

    if (IBM_RTE_isMozilla()) {

        var commentNodes = IBM_RTE_getDocument(editorName).getElementsByTagName("description");
        for (var i = 0; i < commentNodes.length; i++){
        
            var cmtStyle = commentNodes[i].getAttribute("style");

            var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
            var newNode = IBM_RTE_getDocument(editorName).createElementNS(XULNS, "description");
            newNode.setAttribute("value", commentNodes[i].getAttribute("value"));

            commentNodes[i].parentNode.replaceChild(newNode, commentNodes[i]);

//alert(cmtStyle);

            if (cmtStyle != "display: none;"){
                cmtStyle = "display:block; padding:5px; color:red !important; font-style: italic; font-size: 10pt;"
            }
            newNode.setAttribute("style", cmtStyle);
       }
    }
}

//PMR Fix
function IBM_RTE_getCell(editorName)
{

var selRange = IBM_RTE_getSelectionRange(editorName);

var currentRow= selRange.parentElement();

if(currentRow.tagName=="TD")
	{
return currentRow;
	}
	else
	{
 return null;

	}


}

//PMR Fix
function isBlank(val){
	if(val==null){return true;}
	for(var i=0;i<val.length;i++) {
		if ((val.charAt(i)!=' ')&&(val.charAt(i)!="\t")&&(val.charAt(i)!="\n")&&(val.charAt(i)!="\r")){return false;}
		}
	return true;
	}

function IBM_RTE_changeContent(editorName)
{
var iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
iHTML= iHTML.replace(/\<TD\>\<\/TD\>/g, "<TD>&nbsp;</TD>");
IBM_RTE_getDocument(editorName).body.innerHTML=iHTML;
}


