/*
 * InvalidPathException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr;

/**
 * Exception thrown when no <code>Item</code> exists at the specified path
 * or when the specified path implies a different node type from what is
 * expected.
 *
 */
public class InvalidPathException extends RepositoryException {

    /**
     * Constructor that creates a <code>InvalidPathException</code>
     */
    public InvalidPathException() {
        super();
    }

    /**
     * Constructor that creates a <code>InvalidPathException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public InvalidPathException(String s) {
        super(s);
    }

    /**
     * Constructor that creates a <code>InvalidPathException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public InvalidPathException(String s, Exception e) {
        super(s, e);
    }
}
