/*
 * InvalidSerializedDataException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr;

/**
 * Exception thrown by the deserialization methods of <code>Node</code>
 * if an attempt is made to deserialize an invalid stream.
 *
 * @author Peeter Piegaze
 */
public class InvalidSerializedDataException extends RepositoryException {

    /**
     * Class constructor that creates a <code>InvalidSerializedDataException</code>
     */
    public InvalidSerializedDataException() {
        super();
    }

    /**
     * Class constructor that creates a <code>InvalidSerializedDataException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public InvalidSerializedDataException(String s) {
        super(s);
    }

    /**
     * Class constructor that creates a <code>InvalidSerializedDataException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public InvalidSerializedDataException(String s, Exception e) {
        super(s, e);
    }
}
