/*
 * ItemIterator.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr;

/**
 * The <code>ItemIterator</code> extends the
 * <code>Iterator</code> with an type-specific <code>next()</code> method.
 *
 * @author Peeter Piegaze
 */
public interface ItemIterator extends RangeIterator {

    /**
     * Returns the next <code>Item</code> in the iteration.
     *
     * @return the next <code>Item</code> in the iteration.
     *
     * @throws java.util.NoSuchElementException if iteration has no more <code>Item</code>s.
     */
    public Item nextItem();
}
