/*
 * LoginException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr;

/**
 * Exception thrown by <code>{@link Repository#login(Credentials)}</code> and
 * <code>{@link Ticket#impersonate(Credentials)}</code> if the specified
 * credentials are invalid.
 *
 * @author Peeter Piegaze
 */
public class LoginException extends RepositoryException {

    /**
     * Class constructor that creates a <code>LoginException</code>
     */
    public LoginException() {
        super();
    }

    /**
     * Class constructor that creates a <code>LoginException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public LoginException(String s) {
        super(s);
    }

    /**
     * Class constructor that creates a <code>LoginException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public LoginException(String s, Exception e) {
        super(s, e);
    }
}
