/*
 * ValueFormatException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr;

/**
 * Exception thrown when an attempt is made to assign a
 * value to a property that has an invalid syntax, given the
 * type of the property. Also thrown if an attempt is made to read the value of
 * a property using a type-specific read method of a type into which it is not
 * convertable.
 *
 * @author Peeter Piegaze
 */
public class ValueFormatException extends RepositoryException {
    /**
     * Class constructor that creates a <code>ValueFormatException</code>
     */
    public ValueFormatException() {
	    super();
    }

    /**
     * Class constructor that creates a <code>ValueFormatException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public ValueFormatException(String s) {
	    super(s);
    }

    /**
     * Class constructor that creates a <code>ValueFormatException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public ValueFormatException(String s, Exception e) {
	    super(s, e);
    }
}
