/*
 * NoSuchNodeTypeException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr.nodetype;

import javax.jcr.RepositoryException;

/**
 * Exception thrown by node type-related methods.
 *
 * @author Peeter Piegaze
 */
public class NoSuchNodeTypeException extends RepositoryException {
    /**
     * Class constructor that creates a <code>NoSuchNodeTypeException</code>
     */
    public NoSuchNodeTypeException() {
        super();
    }

    /**
     * Class constructor that creates a <code>NoSuchNodeTypeException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public NoSuchNodeTypeException(String s) {
        super(s);
    }

    /**
     * Class constructor that creates a <code>NoSuchNodeTypeException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public NoSuchNodeTypeException(String s, Exception e) {
        super(s, e);
    }
}
