/*
 * EventListener.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr.observation;

/**
 * An event listener.
 * <p>
 * <b>Level 2 only</b>
 * <p>
 * An <code>EventListener</code> can be registered via the
 * <code>{@link javax.jcr.observation.ObservationManager}</code> object. Event listeners are
 * notified asynchronously, and see events after they occur and the transaction
 * is committed. An event listener only sees events for which the ticket that
 * registered it has sufficient access rights.
 *
 * @author tima, ppiegaze
 */
public interface EventListener {

    /**
     * Performs an action upon this listener receiving an event.
     *
     * @param event The event recieved.
     */
    public void onEvent(Event event);
}
