/*
 * InvalidQueryException.java
 *
 * This file is part of the specification for the
 * Java Content Repository API
 */
package javax.jcr.query;

import javax.jcr.RepositoryException;

/**
 * Thrown by some methods javax.jcr.query..
 *
 * @author Peeter Piegaze
 */
public class InvalidQueryException extends RepositoryException {

    /**
     * Class constructor that creates a <code>InvalidQueryException</code>
     */
    public InvalidQueryException() {
        super();
    }

    /**
     * Class constructor that creates a <code>InvalidQueryException</code> given
     * a message describing the failure cause
     * @param s description
     */
    public InvalidQueryException(String s) {
        super(s);
    }

    /**
     * Class constructor that creates a <code>InvalidQueryException</code> given
     * a message describing the failure and a root exception
     * @param s description
     * @param e root failure cause
     */
    public InvalidQueryException(String s, Exception e) {
        super(s, e);
    }
}
